Bug 156146 - CAN-2005-0337 open relay bug in postfix ipv6 patch
CAN-2005-0337 open relay bug in postfix ipv6 patch
Status: CLOSED RAWHIDE
Product: Fedora Legacy
Classification: Retired
Component: postfix (Show other bugs)
fc2
All Linux
medium Severity medium
: ---
: ---
Assigned To: Fedora Legacy Bugs
: Security
Depends On: 146731
Blocks:
  Show dependency treegraph
 
Reported: 2005-04-27 16:51 EDT by Matthew Miller
Modified: 2007-04-18 13:24 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-09-30 11:58:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Matthew Miller 2005-04-27 16:51:06 EDT
+++ This bug was initially created as a clone of Bug #146731 +++

Affects:                Postfix with IPv6 patch on Linux
Credits:                Peer Heinlein

Background
-----------

Postfix is an MTA written by Wietse Venema with security in mind. The
code has a great security record.
Dean Strik provides an IPv6 patch for Postfix releases.

To read IPv6 addresses and netmasks on Linux, the patch uses
/proc/net/if_inet6.

Problem description
--------------------

In some cases, the /proc/net/if_inet6 file is not available. The most
common reason being that Postfix runs chrooted without /proc mounted in
the chroot. A programming error in the IPv6 patch could result in
Postfix relaying emails to destinations that have IPv6 addresses for
their MX hosts.

If /proc/net/if_inet6 is not available, so Postfix does configure any
IPv6 addresses, the permit_mx_backup code erroneously returns success
for relay permissions to any IPv6 host.

The Postfix IPv6 patch documentation (IPV6_README) does note that

 - It is not currently supported to use Postfix network daemons
   (such as smtp and smtpd) chrooted on Linux systems without
   mounting the proc filesystem under /var/spool/postfix/proc
   This is because the proc filesystem is required on Linux to
   obtain the system's IPv6 address information.

So the configuration where /proci is NOT available to Postfix is not
supported.

Impact
-------

The problem is specific to the Linux operating system in unsupported
configuration.

Postfix does not come chrooted by default. The IPv6 patch does not
change this behaviour. Packagers/distributors however may have changed
this setting.

The permit_mx_backup setting is not used by default and must be
specificially configured by the Postfix administrator.

If Postfix cannot read the /proc/net/if_inet6 file and permit_mx_backup
is used, then Postfix will wrongly relay mail only to sites that have
IPv6 addresses (AAAA RRs in DNS) configured for at least one MX host.

Because of these four points, the impact of the relaying bug is very
low.

Affected versions
------------------

Since the problem is in the IPv6 patch to Postfix, the version numbers
used here are those of the IPv6 patch. An administrator can query the
patch version number by issuing the command

        postconf tls_ipv6_version

Patch versions up to and including 1.25 are vulnerable to this problem.
Associated Postfix versions include Postfix 2.1.x and 2.0.x.

Postfix 2.2 snapshots with IPv6 included in the base Postfix
(2.2-20050111-nonprod and up) are NOT vulnerable to the problem.

IPv6 and TLS+IPv6 patch 1.26 provide a correction of the problem.

Credits
--------

Peer Heinlein reported the problem to the IPv6 patch author.

Workarounds
------------

Several workarounds exist for the problem:

 a) Do not run the Postfix smtpd program chrooted.
    This can be achieved by editing master.cf and putting an 'n' in
    the chroot column of the smtpd line;
 b) Make the /proc filesystem available under the chroot.

Solution
---------

Upgrade the Postfix IPv6 patch to version 1.26 or higher. The patches
are available from

        http://www.ipnet6.org/postfix/ipv6/
or
        ftp://ftp.stack.nl/pub/postfix/tls+ipv6/
Comment 1 Matthew Miller 2005-04-27 16:52:20 EDT
My sense is that because this only is a problem in a non-default unsupported
configuration, we can "wontfix" this for Fedora Legacy. But I wanted to point it
out so other FL people can weigh in. Thanks.
Comment 2 Thomas Woerner 2005-09-30 11:58:51 EDT
Closing as fixed in rawhide. There are newer packages available.

Note You need to log in before you can comment on or make changes to this bug.